// (C) Peter Schmitteckert
// Published under the Gnu Public License (GPL)
//

#include <iostream>
#include <stdlib.h>

void Rand_1( double& x, double& y)
{
	x = double(rand()) / RAND_MAX;
	y = double(rand()) / RAND_MAX;
}

void Rand_2( double& x, double& y)
{
	x = drand48();
	y = drand48();
}

int main(int argc, char* argv[])
{
	int N = 25;
 	int nHit = 0;
	double x , y, r;

	if( argc >1 )
		N = atoi( argv[1] );

	for( int i = 0; i < N; ++i)
	{
		//Bestimmung der Zufallszahl
		Rand_1( x, y );

		// Einpassen ins umschlieende Rechteck
		x = 2.0*x - 1.0;
		y = 2.0*y - 1.0;

		// Hit Test
		r = x*x + y*y;
		if( (r <= 1) ) //&& ( fabs(x) <= 0.815 ) && ( fabs(y) <= 0.815 ) )
			++nHit;

		// Ausgabe
		//cout << i << " " << x << '\t' << y << '\t'
		//	<< 4.0 * nHit / double(i+1) << endl;
	}

	cout.precision(12);
	cout << N << '\t' << 4.0 * nHit / double(N) << endl;
}