// (C) Peter Schmitteckert
// Published under the Gnu Public License (GPL)
//

#include <iostream>
#include <stdlib.h>
#include "Sobol.h"

void Rand_Sobol( double& x, double& y)
{
	x = double(rand()) / RAND_MAX;
	y = double(rand()) / RAND_MAX;
}

int main(int argc, char* argv[])
{
	int N = 25;
 	int nHit = 0;
	double x , y, r;
	double v[2];

	sobol_state_t SobolState;

	if( argc >1 )
		N = atoi( argv[1] );

	if( sobol_init( &SobolState, 2) != 0)
		return -1;

	for( int i = 0; i < N; ++i)
	{
		//Bestimmung der Zufallszahl
		if( sobol_get(&SobolState, 2, v))
		return -1;

		// Einpassen ins umschlieende Rechteck
		x = 2.0*v[0] - 1.0;
		y = 2.0*v[1] - 1.0;

		// Hit Test
		r = x*x + y*y;
		if( (r <= 1) && ( fabs(x) <= 0.815 ) && ( fabs(y) <= 0.815 ) )
			++nHit;

		// Ausgabe
		// cout << i << " " << x << '\t' << y << '\t'
		// << 4.0 * nHit / double(i+1) << '\t' << 4.0 * nHit / double(i+1) - 2.5583668440554294676 << endl;
	}

	cout.precision(12);
	cout << N << '\t' << 4.0 * nHit / double(N) << endl;

	return 0;
}