// (C) Peter Schmitteckert
// Published under the Gnu Public License (GPL)
//

#ifndef INCLUDES_Sobol
#define INCLUDES_Sobol

#include <stdlib.h>

/* maximum allowed space dimension */
#define SOBOL_MAX_DIMENSION 40

/* bit count; assumes sizeof(int) >= 32-bit */
#define SOBOL_BIT_COUNT 30

/* prototypes for generator type functions */

/* Sobol generator state.
 *   sequence_count       = number of calls with this generator
 *   last_numerator_vec   = last generated numerator vector
 *   last_denominator_inv = 1/denominator for last numerator vector
 *   v_direction          = direction number table
 */

struct sobol_state_t;
int sobol_init(sobol_state_t * state, unsigned int dimension);
int sobol_get(sobol_state_t * state, unsigned int dimension, double * v);

struct sobol_state_t
{
  unsigned int  sequence_count;
  double        last_denominator_inv;
  int           last_numerator_vec[SOBOL_MAX_DIMENSION];
  int           v_direction[SOBOL_BIT_COUNT][SOBOL_MAX_DIMENSION];

  sobol_state_t()
  {
  };

  sobol_state_t(const unsigned int d)
  {
    sobol_init( this, d);
  };
};



#endif